;;;--------------------------------------------------------------------;;;
;;;                                             ;;;
;;;                   Com_15EN.lsp Version 2.1                         ;;;
;;;                  AutoCAD R14 for Windows                        ;;;
;;;                           24.01.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;

;;
;;         :
;;         , 
;;            
;;                xlineOffset
;;
;;            
;;         
;;                xlineAng
;;
;;          RFill
;;                FilletR
;;
;;          
;;                ChamfLL
;;
;;           
;;                ChamfAng
;;
;;           
;;                DimLineD  DimLineAligD
;;
;;            
;;                DimLine1  DimLineD1 DimLineR1
;;                       DimLineAlig1  DimLineAligD1 DimLineAligR1
;;
;;          
;;                DimAngularL
;;
;;            
;;         
;;                _dimcenter1
;;
;;             
;;                DimDText
;;
;;              
;;                DimLText
;;
;;              
;;                (SetLType X)
;;                X -   :
;;                     0 - 
;;                     1 - 
;;                     2 - 
;;                     3 - 
;;                     4 - 
;;
;;              
;;                SelLType
;;
;;         
;;                DelLHlp
;;
;;           
;;                LinBreak1
;;
;;           
;;                LinBreak
;;
;;          
;;                LinPerish
;;


;=============================================================
;;;  

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

;  
(defun SetOpt ()
	(setq sblip (getvar "BLIPMODE"))
	(setq scmde (getvar "CMDECHO"))
	(setvar "BLIPMODE" 0)
	(setvar "CMDECHO" 0)
)

;  
(defun RetOpt ()
	(setvar "BLIPMODE" sblip)
	(setvar "CMDECHO" scmde)
)

;  OSNAP
(defun Osnap_Off  ()
	(setq sosnapm (getvar "OSMODE"))
	(setvar "OSMODE" 0)
)

;  OSNAP
(defun Osnap_On  ()
	(setvar "OSMODE" sosnapm)
)

;-------------------------------------------------------------

;     
(defun dtr (Ang)
	(/ (* Ang pi) 180)
)

;     
(defun rtd (Ang) 
	 (* Ang (/  180 pi))
)

;  
(defun tan (Ang)
	(setq tangens (/ (sin Ang) (cos Ang)))
	T tangens
)

;    
(defun arcsin ( x / )
    (atan 
        (/  x  (sqrt (- 1.0 (* x x))) )
    )
) ; defun arsin

;-------------------------------------------------------------
;  
(defun getSymL (Sym th scale / cth pt1 SymL TxtPoints)
    ; Sym       - 1   string
    ; cth       -     
    ; scale     - 
    ; SymL      -  
    ; TxtPoints -     
    
    (if (= Sym " ")
        (setq SymL (* th 0.8 scale) )
        (progn
            (setq cth (* th scale))
            (setq TxtPoints (textbox (list (cons 1 Sym) (cons 40 cth))) )
            (setq pt1 (cadr TxtPoints) )
            (setq SymL (car pt1))
        )
    )
    t SymL
)

;  SelObj
(defun MoveObj (SelObj BasePt)
	(command "_Move" SelObj "" bp pause)
	(setq BasePt (getvar "Lastpoint"))
	(princ (strcat "\n : " BasePt))
	T BasePt
)

;  SelObj
(defun RotateObj (SelObj BasePt)
	(princ "\n : ")
	(command "_Rotate" SelObj "" BasePt pause)
)
(defun $SaveLProp ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	;(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun $RetLProp ()
;   
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	;(setvar "CELWEIGHT" oldWeight)
)

(defun $setLTypeDim ()
	(setq TxtCOL (getvar "DIMCLRD"))	    ; , - 
										    ;  

	(setq TxtH (* (getvar "DIMTXT") Scale))	;  
											;  

	(setq ArWD (getvar "DIMLWD"))	        ;  , - 
									        ;  
	
	(setvar "CECOLOR" (rtos TxtCOL 2 0))
	(setvar "CELTYPE" "CONTINUOUS")
	;(setvar "CELWEIGHT" ArWD)
)
;;;   
;=============================================================


;;;  
;=============================================================


;;;   
;=============================================================
;***///\\\***
(defun dimang ( / Obj1 Obj2 Obj1Name Obj1Dat Obj1Type DimEntName DimEntDat sp)
;    
  (setq Obj1 nil)
  (setq Obj2 nil)
  (while (and (null Obj1) (null Obj2))
    (setq Obj1 (entsel "\n , ,   : "))
    (setq Obj1Name (car Obj1))
    (setq Obj1Dat (entget Obj1Name))
    (setq Obj1Type (cdr (assoc 0 Obj1Dat)))
    (cond
        ((= Obj1Type "LINE")
            (progn
                (setq Obj2 nil)
                (while (null Obj2)
                    (setq Obj2 (entsel "\n  : "))
                    (setq Obj2Name (car Obj2))
                    (setq Obj2Dat (entget Obj2Name))
                    (setq Obj2Type (cdr (assoc 0 Obj2Dat)))
                    (if (not (= Obj2Type "LINE"))
                        (progn
                            (setq Obj2 nil)
                            (princ "\n   .")
                        )
                    )
                )
                (princ)
                ;(setq Obj1 Obj1Name )
                ;(setq Obj2 Obj2Name )
                (command "_dimangular" Obj1 Obj2 pause)
                (setq DimEntName (entlast))
                (setq DimEntDat (entget DimEntName))
            )
        )
        ((= Obj1Type "CIRCLE")
            (progn
                (setq Obj2 Obj1)
                (princ)
                (command "_dimangular" Obj1 pause pause)
            )
        )
        ((= Obj1Type "ARC")
            (progn
                (setq Obj2 Obj1)
                (princ)
                (command "_dimangular" Obj1 pause)
                (setq DimEntName (entlast))
                (setq DimEntDat (entget DimEntName))
            )
        )
        ((= Obj1Type "LWPOLYLINE")
            (progn
                (setq Obj2 Obj1)
                (princ)
                (command "_dimangular" Obj1 pause pause)
                (setq DimEntName (entlast))
                (setq DimEntDat (entget DimEntName))
            )
        )
        ((and (/= Obj1Type "ARC") (/= Obj1Type "LWPOLYLINE") (/= Obj1Type "CIRCLE") (/= Obj1Type "LINE"))
            (progn
                (setq Obj1 nil Obj2 nil)
                (princ "\n   ,     .")
            )
        )
    )
  )
    
    
    ;(command "_dimangular" Obj1)

    (setq DimEntName (entlast))
    (setq DimEntDat (entget DimEntName))
    t DimEntDat
)

;    
(defun C:DimAngularL ( / cp sp ep up AngArc RArc DimTxt DimEntName DimEntDat 
                         LArc uRArc uAngArc uLarc uDimTXT Xo uXo )
     
     ;(princ "\n : ")
     ;(command "_dimangular" Pause Pause)
     (setq DimEntDat (dimang))
     ;(setq DimEntName (entlast))
     ;(setq DimEntDat (entget DimEntName))
     ;(setq DimEntDat (dimang))
     (setq cp (cdr (assoc 15 DimEntDat)))     ;  
     (setq sp (cdr (assoc 13 DimEntDat)))     ;   
     (setq ep (cdr (assoc 14 DimEntDat)))     ;   
     (setq up (cdr (assoc 10 DimEntDat)))     ;    
     (setq AngArc (cdr (assoc 42 DimEntDat))) ;  
     (setq RArc (distance ep cp))             ;  
     (setq DimTxt (cdr (assoc 1 DimEntDat)))  ;  
     
     (setq LArc (* RArc AngArc))

     (setq uRArc nil)
     (initget (+ 2 4))
     (setq uRArc (getreal (strcat "\n  <" (rtos RArc 2 4) ">: ")))
     (if (null uRArc) 
         (setq uRArc RArc)
         (setq RArc uRArc)
     )
     
     (setq uAngArc nil)
     (initget "" (+ 2 4))
     (setq uAngArc (getreal (strcat "\n  [] <" (rtos (rtd AngArc) 2 4) ">: ")))
     (if (null uAngArc)
         (setq uAngArc AngArc)
         (if (= uAngArc "")
             (progn
                 (if (<= AngArc Pi)
                     (setq Xo (* 2.0 uRArc (sin (/ AngArc 2.0))))
                     (setq Xo (* 2.0 uRArc (sin (/ (- (* 2.0 pi) AngArc) 2.0))))
                 )
                 
                 (initget (+ 2 4))
                 (setq uXo (getreal (strcat "\n  <" (rtos Xo 2 4) ">: ")))
                 (if (null uXo) 
                     (setq uXo Xo)
                     (setq Xo uXo)
                 )
                 (if (<= AngArc pi)
                     (setq uAngArc (rtd (* 2.0 (arcsin (/ (/ uXo 2.0 uRArc))))))
                     (setq uAngArc (- 360.0 (rtd (* 2.0 (arcsin (/ (/ uXo 2.0) uRArc))))))
                 )
                 (setq uAngArc (dtr uAngArc))
             )
             (setq uAngArc (dtr uAngArc))
         )
     )
     (setq AngArc uAngArc)
     (setq uLArc nil)
     (initget (+ 2 4))
     (setq uLArc (getreal (strcat "\n  <" (rtos (* uRArc uAngArc) 2 4) ">: ")))
     (if (null uLArc) 
         (setq uLArc (* uRArc uAngArc))
         ;;;(setq uLArc (* uRArc AngArc))
     )
     
     (setq uDimTXT (strcat "L=" (rtos (round uLArc 1) 2 1) " no R=" (rtos (round uRArc 1) 2 1)))     
	
	 (setq DimEntDat (subst (cons 1 uDimTXT) (assoc 1 DimEntDat) DimEntDat ))
	 (entmod DimEntDat)
)




;     ""
(defun $DimPerfT ( LEnt Perf)
	(setq Txt (cdr (assoc 1 LEnt)))
	(if (= Txt "") (setq Txt "<>"))
	(setq Txt (strcat Perf Txt))
	(setq LEnt (subst (cons 1 Txt) (assoc 1 LEnt) LEnt ))
	(entmod LEnt)
)

;  
(defun $DimLine (dCom DimPtList / oldDimAso)
    (setq oldDimAso (getvar "DIMASO"))
    (setvar "DIMASO" 1)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (setvar "DIMASO" oldDimAso)
        (GC)
    )
    (if (null DimPtList)
        (command dCom Pause Pause Pause)
        (command dCom (car DimPtList) (cadr DimPtList) Pause)
    )
    (setvar "DIMASO" oldDimAso)
)

;  
;   
(defun $DimLine1 (dCom DimPtList)
    (setq oldDimAso (getvar "DIMASO"))
    (setvar "DIMASO" 1)
    (setq OldDIMSD1 (getvar "DIMSD1"))
    (setq OldDIMSE1 (getvar "DIMSE1"))
    (setvar "DIMSD1" 1)
    (setvar "DIMSE1" 1)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (setvar "DIMSD1" OldDIMSD1)
        (setvar "DIMSE1" OldDIMSE1)
        (setvar "DIMASO" oldDimAso)
        (GC)
    )
    (if (null DimPtList)
        (command dCom Pause Pause Pause)
        (command dCom (car DimPtList) (cadr DimPtList) Pause)
    )
    (setvar "DIMSD1" OldDIMSD1)
    (setvar "DIMSE1" OldDIMSE1)
    (setvar "DIMASO" oldDimAso)
)
;     
;    
(defun C:DimLineD ()
    ($DimLine "_dimlinear" nil)
    ($DimPerfT (entget (entlast)) "%%c")
)

;   
;  
(defun C:DimLineAligD ()
    ($DimLine "_dimaligned" nil)
    ($DimPerfT (entget (entlast)) "%%c")
)

;     
;    
(defun C:DimLine1 ( / pt1 pt2)
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimlinear" (list pt1 pt2))
)


;     
;    
;   
(defun C:DimLineD1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimlinear" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "%%c")
)

;     
;    
;   
(defun C:DimLineR1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimlinear" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "R ")
)

;     
;   
(defun C:DimLineAlig1 ( / pt1 pt2)
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimaligned" (list pt1 pt2))
)

;     
;   
;   
(defun C:DimLineAligD1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimaligned" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "%%c")
)

;     
;    
;   
(defun C:DimLineAligR1 ()
    (setq pt1 (getpoint "\n  : "))
    (setq pt2 (getpoint pt1 "\n  : "))
    ($DimLine1 "_dimaligned" (list pt1 pt2))
    ($DimPerfT (entget (entlast)) "R ")
)

(defun C:dimcenter1 ( / SS)
;      
;   
    (setq SS (ENTSEL "\n   : "))
    (if (not (null SS))
        (progn
            ($SaveLYype)
            ($SetLType 3)
            (command "_dimcenter" SS)
            ($RetLType)
        )
    )
)


;;      
(defun C:DimDText ( / TxtCOL TxtH ArWD scale CurTxtStyle th pTxt)
	(SetOpt)
	($SaveLProp)
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 1)
	    (setq scale (getvar "dimscale"))
	)
    ($setLTypeDim)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (RetOpt)
        ($RetLProp)
        (GC)
    )

	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
    (terpri)
    (princ)
    (princ)
    
    (setq pTxt (getpoint "\n : "))
  
	(if (= th 0.0)
        (command "_dtext" pTxt TxtH )
        (command "_dtext" pTxt )
    )
	(RetOpt)
	($RetLProp)
)

;;       
(defun C:DimLText ( / TxtCOL TxtH ArWD scale CurTxtStyle th pTxt Txt LEnt)
	(SetOpt)

	($SaveLProp)
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 1)
	    (setq scale (getvar "dimscale"))
	)
    ($setLTypeDim)
    (SETQ old_error *error*) 
    (DEFUN *error* ( msg )
        (if old_error (setq *error* old_error))
        (if msg (princ "\n   " ))
        ;   
        (RetOpt)
        ($RetLProp)
        (GC)
    )

	(setq CurTxtStyle (getvar "TEXTSTYLE"))
	(setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
    (terpri)
    (princ)
    (princ)
    (RetOpt)
    (setq pTxt (getpoint "\n : "))
    (setq Txt (getstring t "\n  : "))
    (setq Txt (strcat "%%u" Txt))
	(if (= th 0.0)
        (command "_text" pTxt TxtH 0.0 Txt)
        (command "_text" pTxt 0.0 Txt)
    )
	
	(SetOpt)
	($RetLProp)
	
	(RetOpt)
)

;  , 
;     
(defun C:xlineOffset()
	(setq OfsetD (getvar "OFFSETDIST"))
	(setq OfsetDT (rtos OfsetD))
	(setq OfsetD nil)
	(initget (+ 2 4 ))
	(setq OfsetD (getreal (strcat "\n   <" OfsetDT ">: ")))
	(if (null OfsetD)
		(setq OfsetD (getvar "OFFSETDIST"))
		(setvar "OFFSETDIST" OfsetD)
	)
	(command "_xline" "Offset" OfsetD pause pause)
	
)


;     
;  
(defun C:xlineAng()
	(setq Ang nil)
	(initget (+ 2 4 ))
	(setq Ang (getangle "\n   <0>: "))
	(if (null Ang)
		(setq Ang 0.0)
		(setq Ang (rtd Ang))
	)
	(command "_xline" "Ang" Ang pause)
	
)

;   RFill
(defun C:FilletR()
	(setq RFillT (rtos (getvar "FILLETRAD")))
	(setq RFill (getreal (strcat "\n  <" RFillT ">: ")))
	(if (null RFill) 
		(setq RFill "FILLETRAD")
		(setvar "FILLETRAD" RFill)
	)
	(command "_fillet" )
)


;;
;   
(defun C:ChamfLL()
	(setq D1T (rtos (getvar "chamferA")))
	(setq D2T (rtos (getvar "chamferB")))
	(setq D1 (getdist (strcat "\n     <" D1T ">: ")))
	(if (null D1)
		(setq D1 (getvar "chamferA"))
		(setvar "chamferA" D1)
	)
	(setq D2 (getvar "chamferB"))
	(setq D2T (rtos (getvar "chamferB")))
	(setq D2 (getdist (strcat "\n     <" D2T ">: ")))
	(if (null D2) 
		(setq D2 (getvar "chamferB")) 
		(setvar "chamferB" D2)
	)

	(command "_chamfer" "D" D1 D2)
	
	(command "_chamfer")
	(prin1)
)

;    
(defun C:ChamfAng()
	(setq D1 (getvar "chamferC"))
	(setq D1T (rtos D1))
	(setq D1 (getdist (strcat "\n     <" D1T ">: ")))
	(if (null D1) 
		(setq D1 (getvar "chamferC"))
		(setvar "chamferC" D1)
	)
	
	(setq Ang1 (getvar "chamferD"))
	(setq Ang1T (rtos (rtd Ang1)))
	(setq Ang1 (getangle (strcat "\n    <" Ang1T ">: ")))
	(if (null Ang1)
		(setq Ang1 (rtd (getvar "chamferD")))
		(progn
			(setq Ang1 (rtd Ang1))
			(setvar "chamferD" Ang1)
		)
	)
	
	(command "_chamfer" "A" D1 Ang1)
	
	(command "_chamfer")
	(prin1)
)

;=====================================================;
;    

(defun $SaveLYype ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	;(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun $SetLType (LinType)
;    
	(cond
	    ((= LinType 0)	;
		    (progn
			    (setvar "CECOLOR" (rtos 6 2 0))
			    (setvar "CELTYPE" "CONTINUOUS")
			    ;(setvar "CELWEIGHT" 0)
		    )
	    )
	    ((= LinType 1)	;
		    (progn
			    (setvar "CECOLOR" (rtos 7 2 0))
			    (setvar "CELTYPE" "CONTINUOUS")
			    ;(setvar "CELWEIGHT" 60)
		    )
	    )
	    ((= LinType 2)	;
    		(progn
			    (setvar "CECOLOR" (rtos 1 2 0))
			    (setvar "CELTYPE" "CONTINUOUS")
			    ;(setvar "CELWEIGHT" 20)
		    )
	    )
	    ((= LinType 3)	;
		    (progn
    			(setvar "CECOLOR" (rtos 1 2 0))
	    		(if (null (tblsearch "ltype" ""))
		    	    (command "-linetype" "l" "" "ESKD" "")
			    )
			    (setvar "CELTYPE" "")
			    ;(setvar "CELWEIGHT" 20)
		    )
	    )
	    ((= LinType 4)	;
		    (progn
			    (setvar "CECOLOR" (rtos 5 2 0))
			    (if (null (tblsearch "ltype" ""))
    			    (command "-linetype" "l" "" "ESKD" "")
	    		)
		    	(setvar "CELTYPE" "")
			    ;(setvar "CELWEIGHT" 40)
		    )
	    )
	)
)

(defun $SetLTypeObj ( SS LinType / l_Color l_Type l_Weight Count Obj EntDat EntType )
;      
    (cond
        ((= LinType 0)	;
		    (progn
			    (setq l_Color 6)
			    (setq l_Type "CONTINUOUS")
			    (setq l_Weight 0)
		    )
		)
		((= LinType 1)	;
		    (progn
			    (setq l_Color 7)
			    (setq l_Type "CONTINUOUS")
			    (setq l_Weight 60)
		    )
		)
		((= LinType 2)	;
		    (progn
			    (setq l_Color 1)
			    (setq l_Type "CONTINUOUS")
			    (setq l_Weight 20)
		    )
		)
		((= LinType 3)	;
		    (progn
			    (setq l_Color 1)
			    (if (null (tblsearch "ltype" ""))
			        (command "-linetype" "l" "" "ESKD" "")
			    )
			    (setq l_Type "")
			    (setq l_Weight 20)
		    )
		)
		((= LinType 4)	;
		    (progn
			    (setq l_Color 5)
			    (if (null (tblsearch "ltype" ""))
			        (command "-linetype" "l" "" "ESKD" "")
			    )
			    (setq l_Type "")
			    (setq l_Weight 40)
		    )
		)
    )
   
    (setq Count (- (sslength SS) 1))

    (while (>= count 0)
        (setq Obj (ssname SS Count))
        (setq EntDat (entget Obj))
        (setq EntType (cdr (assoc 0 EntDat)))
        (if (or (= EntType "LWPOLYLINE") (= EntType "SPLINE"))
            (modify_LinType_comp Obj l_Color l_Type l_Weight)
            (modify_LinType Obj l_Color l_Type l_Weight)
        )
        (setq count (- Count 1))
    )
)

(defun modify_LinType (e_name l_Color l_Type l_Weight / e_list )
;     
    (setq e_list (entget e_name))
    (setq e_list (lt_mod e_list l_Color 62))
    (setq e_list (lt_mod e_list l_Type 6))
    (setq e_list (lt_mod e_list l_Weight 370))
    (entmod e_list)
)

(defun lt_mod (e_list value bit / old_e_list)
;       
;  e_list   bit   value
    (if (setq old_e_list (cdr (assoc bit e_list)))
        (setq e_list (subst (cons bit value) (assoc bit e_list) e_list))
        (setq e_list (append e_list (list (cons bit value))))
    )
    t e_list
)

(defun modify_LinType_comp (e_name l_Color l_Type l_Weight / e_list save-e_name save-e_list)
;     
    (setq e_list (entget e_name))
    (modify_LinType e_name l_Color l_Type l_Weight)
    ;; Added to take care of updating Vertex information for color
    ;; and linetype.
    (setq save-e_name e_name save-e_list e_list)
    (if (= (cdr (assoc 0 e_list)) "LWPOLYLINE")
        (progn
            (setq e_list (lt_mod e_list l_Color 62))
            (setq e_list (lt_mod e_list l_Type 6))
            (setq e_list (lt_mod e_list l_Weight 370))
            (entmod e_list)
        )
        (progn
            (setq e_name (entnext save-e_name))
            (setq e_list (entget e_name))

            (while (not (= (cdr (assoc 0 e_list)) "SEQEND"))
                (setq e_list (lt_mod e_list l_Color 62))
                (setq e_list (lt_mod e_list l_Type 6))
                (setq e_list (lt_mod e_list l_Weight 370))
                (entmod e_list)
                (setq e_name (entnext e_name))
                (setq e_list (entget e_name))
            )
        )
    )
    ;; Update the SEQEND
    (if (= (cdr (assoc 0 e_list)) "SEQEND")
      (progn
          (setq e_list (lt_mod e_list l_Color 62))
          (setq e_list (lt_mod e_list l_Type 6))
          (setq e_list (lt_mod e_list l_Weight 370))
          (entmod e_list)
      )
    )
    ;; Go back to header.
    (setq e_name save-e_name e_list save-e_list)

    (entupd e_name)
)


(defun $RetLType ()
;    
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	;(setvar "CELWEIGHT" oldWeight)
)

(defun $drwLinBreak1 (sp ep scale SS / angL L1 p1 p2 p2_1 p3 p3_1 p4 l_List )
;      
    ($SaveLYype)
    ($SetLType 2)
    (setq angL (angle sp ep))
    (setq L1 (distance sp ep))
    (osnap_off)
    (if (<= L1 (* 5 scale))
        (command "_pline" sp ep "")
        (progn
            (setq p1 (polar sp angL (- (/ L1 2) scale)))
            (setq p2_1 (polar p1 angL (/ scale 2)))
            (setq p2 (polar p2_1 (+ angL (dtr 90)) scale))
            (setq p3_1 (polar p2_1 angL scale))
            (setq p3 (polar p3_1 (- angL (dtr 90)) scale))
            (setq p4 (polar p3_1 angL (/ scale 2)))
            (command "_pline" sp p1 p2 p3 p4 ep "")
        )
    )
    (osnap_on)
    ($RetLType)
    (ssadd (entlast) SS)
    t SS
)

(defun SetLType (LinType / ss1)
;    
    ($SaveLYype)
    (if (null (setq ss1 (cadr (ssgetfirst)))) ;     
        ($SetLType LinType)        ;    
        ($SetLTypeObj ss1 LinType) ;      
    )
)

;=============================================================;
;    




;=============================================================;
;     
(defun im_ImgBoot (Tile SlideName f_color / x y)
  (setq	x (dimx_tile Tile)
	y (dimy_tile Tile)
  )
  (start_image Tile)
  (fill_image 0 0 x y f_color)
  (slide_image 0 0 x y SlideName)
  (end_image)
)

(defun bad_par_SelLType ( / LT)
    (setq LT (get_tile "lbl_LType"))
    (if (or (= LT  "") (= LT "") (= LT "") (= LT  "") (= LT ""))
        (progn
            t (done_dialog 1)
        )
        (set_tile "error" "   ")
    )
)

(defun act_B0 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 0)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 141 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B1 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 1)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 141 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B2 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 2)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 141 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B3 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 3)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 141 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B4 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 4)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 141 )

)

;=============================================================;
;      

(defun GeTLType ( / )
;       
;    
    (setq dcl_id (load_dialog "ESKD_Lin.dcl"))

    (if (not (new_dialog "ESKD_Lin" dcl_id))    ;   .
        (exit)                                  ; ,     
    )
    (action_tile "B0" "(act_B0)")
    (action_tile "B1" "(act_B1)")
    (action_tile "B2" "(act_B2)")
    (action_tile "B3" "(act_B3)")
    (action_tile "B4" "(act_B4)")
    (action_tile "accept" "(bad_par_SelLType)")

    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
    
    (action_tile "Ok" "(done_dialog 1)")
    (action_tile "cancel" "(progn (done_dialog 0) (setq Lin_Type nil)")
    (if ( = 1 (start_dialog))
        (progn
            (unload_dialog dcl_id)
        )
        (progn
            (setq Lin_Type nil)
            (unload_dialog dcl_id)
        )
    )
    t Lin_Type 
)

(defun C:LinBreak1 ( / pt1 pt2 L angL scale nSegm lLeft l_List SS SS1 sp ep )
;     
    (SetOpt)
    (setq pt1 (getpoint "\n   : "))
    (setq pt2 (getpoint pt1 "\n   : "))
    (setq L (distance pt1 pt2))
    (setq Scale (* 4 (getvar "dimscale")))	;  
            							;    
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 4)
	)
    (if (< L (* 6 scale))
        (progn
            (princ)
            (princ "\n   .      ")
        )
        (progn
            (setq angL (angle pt1 pt2))
            (setq nSegm (fix (/ L (* 6 scale))))
            (setq lLeft L)
            (setq sp pt1)
            (setq SS (ssadd))
	        (while (> lLeft (* 6 scale))
                (setq ep (polar sp angL (* 6 scale)))
                (setq SS ($drwLinBreak1 sp ep scale SS))
                (setq sp ep)
                (setq lLeft (- lLeft (* 6 scale)))
            )
            (setq SS ($drwLinBreak1 sp pt2 scale SS))
            (setq SS1 (ssadd))
            (ssadd (entlast) SS1)
            (command "_pedit" SS1 "Join" SS "" "")
        )
    )
    (RetOpt)
)

(defun C:LinBreak ( )
;     
    (setq pt (getpoint "\n : "))
    (princ "\n : ")
    ($SaveLYype)
    ($SetLType 2)
    (command "_spline" pt pause)
    ($RetLType)
)

(defun C:LinPerish ( / sp ep scale mp L angL SS angT K CurTxtStyle th )
;    
    (SetOpt)
    (setq K 0.87)
    (setq Scale (getvar "dimscale"))	;  
            							;    
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 1)
	)
    (setq sp (getpoint "\n   : "))
    (setq ep (getpoint sp "\n   : "))
    (setq L (distance sp ep))
    (if (< L (* 5 scale))
        (princ "\n    .      ")
        (progn
            (setq angL (angle sp ep))
            (setq mp (polar sp angL (/ L 2)))
            (setq mp1 (polar sp angL (/ L 4)))
            (setq mp2 (polar ep (- angL (dtr 180)) (/ L 4)))
            (if (>= (cos angL) 0)
                (setq angT angL)
                (setq angT (- angL (dtr 180)))
            )
            (setq SS (ssadd))
            (osnap_off)
            ($SaveLYype)
            ($SetLType 2)
            (command "_line" sp ep "")
            (ssadd (entlast) SS)
            (command "_line" 
                (polar mp1 (+ angT (dtr 60)) (* scale K))
                (polar mp1 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            (setq mp1 (polar mp1 angL (* 0.5 scale)))
            (command "_line" 
                (polar mp1 (+ angT (dtr 60)) (* scale K))
                (polar mp1 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            (command "_line" 
                (polar mp2 (+ angT (dtr 60)) (* scale K))
                (polar mp2 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            (setq mp2 (polar mp2 angL (* 0.5 scale)))
            (command "_line" 
                (polar mp2 (+ angT (dtr 60)) (* scale K))
                (polar mp2 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            
            (setq mp (polar mp (+ angT 90) (* 0.5 scale)))
            (setq CurTxtStyle (getvar "TEXTSTYLE"))
	        (setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
	        (if (= th 0.0)
		        (command "_text" "Justify" "Center" mp (* 2.5 scale) (rtd angT) "..")
		        (command "_text" "Justify" "Center" mp (rtd angT) "..")
            )
            (ssadd (entlast) SS)
    
            (UnBlock sp ss)
            ($RetLType)
        
            (osnap_on)
        )
    )
    (RetOpt)
)

(defun C:DelLHlp ()
;  "  "
    (command "_erase" (ssget "X" '((370 . 0)))) ;    
                                                ;     0
)

(defun C:SelLType ( / LinType)
;    
;    
    (setq LinType (GetLType))
    (SetLType LinType)
)

;=============================================================
(princ "\n     Com_15EN.lsp  ")
(princ "\n***                   ACAD TOOLS.  COMMANDS                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
