;;;--------------------------------------------------------------------;;;
;;;                                        ;;;
;;;                   ESKD_Lin.lsp Version 2.1                         ;;;
;;;                  AutoCAD R14 for Windows                        ;;;
;;;                           24.01.00                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;


;;
;;         :
;;              
;;                (SetLType X)
;;                X -   :
;;                     0 - 
;;                     1 - 
;;                     2 - 
;;                     3 - 
;;                     4 - 
;;
;;              
;;                SelLType
;;
;;         
;;                DelLHlp
;;
;;           
;;                LinBreak1
;;
;;           
;;                LinBreak
;;
;;          
;;                LinPerish
;;

;=============================================================;
;;;  

;         
(defun UnBlock (pt ss / blkDat bn count Obj Objd Onjn blkName insDat insName)
    ; pt -   
    ; ss -  ,      
    ;            SSGET  SSADD
    
    (setq blkDat (list (cons 0 "BLOCK") (cons 2 "*Unnn") (cons 10 pt) (cons 70 1)) )
    (setq bn (entmake blkDat))
    
    (setq count (- (sslength ss) 1))
    (while (>= count 0)
        (setq Obj (ssname ss count))
        (setq Objd (entget Obj))
        (entdel Obj)
        (setq Onjn (entmake Objd))
        (setq count (- count 1))
    )
    (setq blkName (entmake '((0 . "ENDBLK")) ))
    (setq insDat (list (cons 0 "INSERT") (cons 2 blkName) (cons 10 pt) (cons 70 1)) )
    (setq insName (entmake insDat))
)

(defun $SaveLYype ()
;  
	(setq oldColor (getvar "CECOLOR"))	;  
	(setq oldLType (getvar "CELTYPE"))	;   
	;(setq oldWeight (getvar "CELWEIGHT"))	;  
)

(defun $SetLType (LinType)
;    
	(cond
	    ((= LinType 0)	;
		    (progn
			    (setvar "CECOLOR" (rtos 6 2 0))
			    (setvar "CELTYPE" "CONTINUOUS")
			    ;(setvar "CELWEIGHT" 0)
		    )
	    )
	    ((= LinType 1)	;
		    (progn
			    (setvar "CECOLOR" (rtos 7 2 0))
			    (setvar "CELTYPE" "CONTINUOUS")
			    ;(setvar "CELWEIGHT" 60)
		    )
	    )
	    ((= LinType 2)	;
    		(progn
			    (setvar "CECOLOR" (rtos 1 2 0))
			    (setvar "CELTYPE" "CONTINUOUS")
			    ;(setvar "CELWEIGHT" 20)
		    )
	    )
	    ((= LinType 3)	;
		    (progn
    			(setvar "CECOLOR" (rtos 1 2 0))
	    		(if (null (tblsearch "ltype" ""))
		    	    (command "-linetype" "l" "" "ESKD" "")
			    )
			    (setvar "CELTYPE" "")
			    ;(setvar "CELWEIGHT" 20)
		    )
	    )
	    ((= LinType 4)	;
		    (progn
			    (setvar "CECOLOR" (rtos 5 2 0))
			    (if (null (tblsearch "ltype" ""))
    			    (command "-linetype" "l" "" "ESKD" "")
	    		)
		    	(setvar "CELTYPE" "")
			    ;(setvar "CELWEIGHT" 40)
		    )
	    )
	)
)

(defun $SetLTypeObj ( SS LinType / l_Color l_Type l_Weight Count Obj EntDat EntType )
;      
    (cond
        ((= LinType 0)	;
		    (progn
			    (setq l_Color 6)
			    (setq l_Type "CONTINUOUS")
			    (setq l_Weight 0)
		    )
		)
		((= LinType 1)	;
		    (progn
			    (setq l_Color 7)
			    (setq l_Type "CONTINUOUS")
			    (setq l_Weight 60)
		    )
		)
		((= LinType 2)	;
		    (progn
			    (setq l_Color 1)
			    (setq l_Type "CONTINUOUS")
			    (setq l_Weight 20)
		    )
		)
		((= LinType 3)	;
		    (progn
			    (setq l_Color 1)
			    (if (null (tblsearch "ltype" ""))
			        (command "-linetype" "l" "" "ESKD" "")
			    )
			    (setq l_Type "")
			    (setq l_Weight 20)
		    )
		)
		((= LinType 4)	;
		    (progn
			    (setq l_Color 5)
			    (if (null (tblsearch "ltype" ""))
			        (command "-linetype" "l" "" "ESKD" "")
			    )
			    (setq l_Type "")
			    (setq l_Weight 40)
		    )
		)
    )
   
    (setq Count (- (sslength SS) 1))

    (while (>= count 0)
        (setq Obj (ssname SS Count))
        (setq EntDat (entget Obj))
        (setq EntType (cdr (assoc 0 EntDat)))
        (if (or (= EntType "LWPOLYLINE") (= EntType "SPLINE"))
            (modify_LinType_comp Obj l_Color l_Type l_Weight)
            (modify_LinType Obj l_Color l_Type l_Weight)
        )
        (setq count (- Count 1))
    )
)

(defun modify_LinType (e_name l_Color l_Type l_Weight / e_list )
;     
    (setq e_list (entget e_name))
    (setq e_list (lt_mod e_list l_Color 62))
    (setq e_list (lt_mod e_list l_Type 6))
    (setq e_list (lt_mod e_list l_Weight 370))
    (entmod e_list)
)

(defun lt_mod (e_list value bit / old_e_list)
;       
;  e_list   bit   value
    (if (setq old_e_list (cdr (assoc bit e_list)))
        (setq e_list (subst (cons bit value) (assoc bit e_list) e_list))
        (setq e_list (append e_list (list (cons bit value))))
    )
    t e_list
)

(defun modify_LinType_comp (e_name l_Color l_Type l_Weight / e_list save-e_name save-e_list)
;     
    (setq e_list (entget e_name))
    (modify_LinType e_name l_Color l_Type l_Weight)
    ;; Added to take care of updating Vertex information for color
    ;; and linetype.
    (setq save-e_name e_name save-e_list e_list)
    (if (= (cdr (assoc 0 e_list)) "LWPOLYLINE")
        (progn
            (setq e_list (lt_mod e_list l_Color 62))
            (setq e_list (lt_mod e_list l_Type 6))
            (setq e_list (lt_mod e_list l_Weight 370))
            (entmod e_list)
        )
        (progn
            (setq e_name (entnext save-e_name))
            (setq e_list (entget e_name))

            (while (not (= (cdr (assoc 0 e_list)) "SEQEND"))
                (setq e_list (lt_mod e_list l_Color 62))
                (setq e_list (lt_mod e_list l_Type 6))
                (setq e_list (lt_mod e_list l_Weight 370))
                (entmod e_list)
                (setq e_name (entnext e_name))
                (setq e_list (entget e_name))
            )
        )
    )
    ;; Update the SEQEND
    (if (= (cdr (assoc 0 e_list)) "SEQEND")
      (progn
          (setq e_list (lt_mod e_list l_Color 62))
          (setq e_list (lt_mod e_list l_Type 6))
          (setq e_list (lt_mod e_list l_Weight 370))
          (entmod e_list)
      )
    )
    ;; Go back to header.
    (setq e_name save-e_name e_list save-e_list)

    (entupd e_name)
)


(defun $RetLType ()
;    
	(setvar "CECOLOR" oldColor)
	(setvar "CELTYPE" oldLType)
	;(setvar "CELWEIGHT" oldWeight)
)

(defun $drwLinBreak1 (sp ep scale SS / angL L1 p1 p2 p2_1 p3 p3_1 p4 l_List )
;      
    ($SaveLYype)
    ($SetLType 2)
    (setq angL (angle sp ep))
    (setq L1 (distance sp ep))
    (osnap_off)
    (if (<= L1 (* 5 scale))
        (command "_pline" sp ep "")
        (progn
            (setq p1 (polar sp angL (- (/ L1 2) scale)))
            (setq p2_1 (polar p1 angL (/ scale 2)))
            (setq p2 (polar p2_1 (+ angL (dtr 90)) scale))
            (setq p3_1 (polar p2_1 angL scale))
            (setq p3 (polar p3_1 (- angL (dtr 90)) scale))
            (setq p4 (polar p3_1 angL (/ scale 2)))
            (command "_pline" sp p1 p2 p3 p4 ep "")
        )
    )
    (osnap_on)
    ($RetLType)
    (ssadd (entlast) SS)
    t SS
)

(defun SetLType (LinType / ss1)
;    
    ($SaveLYype)
    (if (null (setq ss1 (cadr (ssgetfirst)))) ;     
        ($SetLType LinType)        ;    
        ($SetLTypeObj ss1 LinType) ;      
    )
)

;=============================================================;
;    




;=============================================================;
;     
(defun im_ImgBoot (Tile SlideName f_color / x y)
  (setq	x (dimx_tile Tile)
	y (dimy_tile Tile)
  )
  (start_image Tile)
  (fill_image 0 0 x y f_color)
  (slide_image 0 0 x y SlideName)
  (end_image)
)

(defun bad_par_SelLType ( / LT)
    (setq LT (get_tile "lbl_LType"))
    (if (or (= LT  "") (= LT "") (= LT "") (= LT  "") (= LT ""))
        (progn
            t (done_dialog 1)
        )
        (set_tile "error" "   ")
    )
)

(defun act_B0 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 0)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 141 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B1 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 1)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 141 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B2 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 2)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 141 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B3 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 3)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 141 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
)

(defun act_B4 ()
    (set_tile "lbl_LType" "")
    (setq Lin_Type 4)
    (set_tile "error" " ")
    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 141 )

)

;=============================================================;
;      

(defun GeTLType ( / )
;       
;    
    (setq dcl_id (load_dialog "ESKD_Lin.dcl"))

    (if (not (new_dialog "ESKD_Lin" dcl_id))    ;   .
        (exit)                                  ; ,     
    )
    (action_tile "B0" "(act_B0)")
    (action_tile "B1" "(act_B1)")
    (action_tile "B2" "(act_B2)")
    (action_tile "B3" "(act_B3)")
    (action_tile "B4" "(act_B4)")
    (action_tile "accept" "(bad_par_SelLType)")

    (im_ImgBoot "B0" "ESKD_Lin(Lin0)" 0 )
    (im_ImgBoot "B1" "ESKD_Lin(Lin1)" 0 )
    (im_ImgBoot "B2" "ESKD_Lin(Lin2)" 0 )
    (im_ImgBoot "B3" "ESKD_Lin(Lin3)" 0 )
    (im_ImgBoot "B4" "ESKD_Lin(Lin4)" 0 )
    
    (action_tile "Ok" "(done_dialog 1)")
    (action_tile "cancel" "(progn (done_dialog 0) (setq Lin_Type nil)")
    (if ( = 1 (start_dialog))
        (progn
            (unload_dialog dcl_id)
        )
        (progn
            (setq Lin_Type nil)
            (unload_dialog dcl_id)
        )
    )
    t Lin_Type 
)

(defun C:LinBreak1 ( / pt1 pt2 L angL scale nSegm lLeft l_List SS SS1 sp ep )
;     
    (SetOpt)
    (setq pt1 (getpoint "\n   : "))
    (setq pt2 (getpoint pt1 "\n   : "))
    (setq L (distance pt1 pt2))
    (setq Scale (* 4 (getvar "dimscale")))	;  
            							;    
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 4)
	)
    (if (< L (* 6 scale))
        (progn
            (princ)
            (princ "\n   .      ")
        )
        (progn
            (setq angL (angle pt1 pt2))
            (setq nSegm (fix (/ L (* 6 scale))))
            (setq lLeft L)
            (setq sp pt1)
            (setq SS (ssadd))
	        (while (> lLeft (* 6 scale))
                (setq ep (polar sp angL (* 6 scale)))
                (setq SS ($drwLinBreak1 sp ep scale SS))
                (setq sp ep)
                (setq lLeft (- lLeft (* 6 scale)))
            )
            (setq SS ($drwLinBreak1 sp pt2 scale SS))
            (setq SS1 (ssadd))
            (ssadd (entlast) SS1)
            (command "_pedit" SS1 "Join" SS "" "")
        )
    )
    (RetOpt)
)

(defun C:LinBreak ( )
;     
    (setq pt (getpoint "\n : "))
    (princ "\n : ")
    ($SaveLYype)
    ($SetLType 2)
    (command "_spline" pt pause)
    ($RetLType)
)

(defun C:LinPerish ( / sp ep scale mp L angL SS angT K CurTxtStyle th )
;    
    (SetOpt)
    (setq K 0.87)
    (setq Scale (getvar "dimscale"))	;  
            							;    
	(if (= (getvar "TILEMODE") 0)       ;   
		(setq scale 1)
	)
    (setq sp (getpoint "\n   : "))
    (setq ep (getpoint sp "\n   : "))
    (setq L (distance sp ep))
    (if (< L (* 5 scale))
        (princ "\n    .      ")
        (progn
            (setq angL (angle sp ep))
            (setq mp (polar sp angL (/ L 2)))
            (setq mp1 (polar sp angL (/ L 4)))
            (setq mp2 (polar ep (- angL (dtr 180)) (/ L 4)))
            (if (>= (cos angL) 0)
                (setq angT angL)
                (setq angT (- angL (dtr 180)))
            )
            (setq SS (ssadd))
            (osnap_off)
            ($SaveLYype)
            ($SetLType 2)
            (command "_line" sp ep "")
            (ssadd (entlast) SS)
            (command "_line" 
                (polar mp1 (+ angT (dtr 60)) (* scale K))
                (polar mp1 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            (setq mp1 (polar mp1 angL (* 0.5 scale)))
            (command "_line" 
                (polar mp1 (+ angT (dtr 60)) (* scale K))
                (polar mp1 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            (command "_line" 
                (polar mp2 (+ angT (dtr 60)) (* scale K))
                (polar mp2 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            (setq mp2 (polar mp2 angL (* 0.5 scale)))
            (command "_line" 
                (polar mp2 (+ angT (dtr 60)) (* scale K))
                (polar mp2 (- angT (dtr 120)) (* scale K))
                ""
            )
            (ssadd (entlast) SS)
            
            (setq mp (polar mp (+ angT 90) (* 0.5 scale)))
            (setq CurTxtStyle (getvar "TEXTSTYLE"))
	        (setq th (cdr (assoc 40 (tblsearch "style" CurTxtStyle))))
	        (if (= th 0.0)
		        (command "_text" "Justify" "Center" mp (* 2.5 scale) (rtd angT) "..")
		        (command "_text" "Justify" "Center" mp (rtd angT) "..")
            )
            (ssadd (entlast) SS)
    
            (UnBlock sp ss)
            ($RetLType)
        
            (osnap_on)
        )
    )
    (RetOpt)
)

(defun C:DelLHlp ()
;  "  "
    (command "_erase" (ssget "X" '((370 . 0)))) ;    
                                                ;     0
)

(defun C:SelLType ( / LinType)
;    
;    
    (setq LinType (GetLType))
    (SetLType LinType)
)


;======================================
(princ "\n     ESKD_Lin.lsp  ")
(princ "\n***                   ACAD TOOLS.  COMMANDS                   ***")
(princ "\n***  , E-Mail: tb5@ugm.zsmk.nvkz.kuzbass.net ***")
