;;;--------------------------------------------------------------------;;;
;;;                                            ;;;
;;;                     Ring.LSP Version 1.1                           ;;;
;;;               AutoCAD 2000 (15) for Windows                     ;;;
;;;                           22.12.99                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;


;;
;;          
;;    :
;;    -  Ring
;;

;;
;;   !!!
;;          
;;    Com_15EN.lsp.    ,   
;;    Com_15EN.lsp      AutoCAD
;;      UTILITES   Com_15EN.mnu 
;;    Com_15EN.lsp     
;;    Com_15EN.mnl.
;;


;=============================================================

;  
;   : Ring
(defun $Ring ( / scmde       InpMode 
				 RRingnar    RRingvn
				 bp          SelObj
				 R1          R2
				 BlkName     S1)
				 
	(setq scmde (getvar "CMDECHO"))
	(initget 1 " ")
	(setq RRingnar (getdist "\n/<  >: "))
	(if (/= RRingnar "") (setq InpMode 1))
	(if (= RRingnar "")
		(progn
			(setq InpMode 2)
			(initget 1)
			(setq RRingnar (getdist "\n  : "))
			(setq RRingnar (/ RRingnar 2))
		)

	)
	(if (= InpMode 1)
		(progn
			(initget 1 " ")		
			(setq RRingvn (getdist "\n/<  >: "))
			(if (= RRingvn "")
				(progn
					(initget 1)
					(setq RRingvn (getdist "\n  : "))
					(setq RRingvn (/ RRingvn 2))
				)
			)
		)
	)
	(if (= InpMode 2)
		(progn
			(initget 1 " ")		
			(setq RRingvn (getdist "\n/<  >: "))
			(if (= RRingvn "")
				(progn
					(initget 1)
					(setq RRingvn (getdist "\n  : "))
					(setq RRingvn (* RRingvn 2))
				)
			)
			(setq RRingvn (/ RRingvn 2))
		)
 	)

	(setq bp (list 100000.0 100000.0 0.0))
	(setq SelObj (DrwRing bp RRingvn RRingnar))
	
	(if (> RRingnar RRingvn)
		(progn
			(setq R1 RRingnar)
			(setq R2 RRingvn)
		)
		(progn
			(setq R1 RRingvn)
			(setq R2 RRingnar)
		)
	)
	(setq BlkName (strcat "Dt_D" (rtos R1 2 0) "d" (rtos R2 2 0)))
	
	(if (null (tblsearch "BLOCK" BlkName))
		(command "-block" BlkName bp SelObj "")
		(command "-block" BlkName "Y" bp SelObj "")
	)
	(prin1)
	(command "-insert" BlkName pause "" "" "")
    (prin1)
    (setq S1 nil)
	(setvar "CMDECHO" scmde)
	(prin1)
)

(defun DrwRing (cp RRingvn RRingnar / S1)
 	(setq S1 nil)
 	(setq S1 (ssadd))
 	(command "_CIRCLE" cp RRingvn)
 	(ssadd (entlast) S1)
 	(command "_CIRCLE" cp RRingnar)
 	(ssadd (entlast) S1)
 	T S1
	
)

(defun C:Ring ()
	($Ring)
	(princ)
)

;=============================================================
(princ "\n     Ring  ")
