;;;--------------------------------------------------------------------;;;
;;;                                 ;;;
;;;                    Sector.lsp Version 1.1                          ;;;
;;;               AutoCAD 2000 (15) for Windows                     ;;;
;;;                           22.12.99                                 ;;;
;;;                   :                          ;;;
;;;                           ;;;
;;;         "-  "           ;;;
;;;                 .     .59-16-23                     ;;;
;;;             E-Mail:  tb5@ugm.zsmk.nvkz.kuzbass.net                 ;;;
;;;--------------------------------------------------------------------;;;


;;
;;          
;;   :
;;       :
;;           (  )     -  SectorA
;;           (  )  
;;             (  )      -  SectorX
;;           (  )  
;;              (  ) -  SectorL
;;

;;
;;   !!!
;;          
;;    Com_15EN.lsp.    ,   
;;    Com_15EN.lsp      AutoCAD
;;      UTILITES   Com_15EN.mnu 
;;    Com_15EN.lsp     
;;    Com_15EN.mnl.
;;

;=============================================================

;; 
;  
(defun getSectRad ()
	(while (or (<= SRadNar 0) (<= SRadVn 0) (< SRadNar SRadVn) (> SWidth SRadNar) (= SRadNar "") (= SRadVn ""))
		(initget 1 " ")
		(setq SRadNar (getreal "\n  /<  >:"))
		(if (= SRadNar "") 
			(progn
				(setq SRadNar 0)
				(initget 1)
				(setq SRadVn (getreal "\n  :"))
 			)
		) 
		
		(if (= SRadVn 0)
			(progn
				(initget 1 " ")
				(setq SRadVn (getreal "\n /<  >:"))
				(if (= SRadVn "")
					(progn
						(setq SRadVn 0)
						(initget 1)
						(setq SWidth (getreal "\n :"))
						(if (and (> SWidth 0) (> SRadNar 0)) (setq SRadVn (- SRadNar SWidth)))
					)
				)
			)
		)
		
		(if (= SRadNar 0)
			(progn
				(setq SRadNar 0)
				(initget 1 " ")
				(setq SRadNar (getreal "\n /<  >:"))
				(if (= SRadNar "")
					(progn
						(setq SRadNar 0)
						(initget 1)
						(setq SWidth (getreal "\n :"))
						(if (and (> SWidth 0) (> SRadVn 0)) (setq SRadNar(+ SRadVn SWidth)))
					)
				)

			)
		) 
		(if (< SRadNar SRadVn)
			(progn
				(princ (strcat "   (" (rtos SRadVn) ")      (" (rtos SRadNar) ")."))
				(setq SRadVn 0)
				(setq SRadNar 0)
			)
		)
		(if (> SWidth SRadNar)
			(progn
				(princ (strcat "   (" (rtos SRadNar) ")      (" (rtos SWidth) ")."))
				(setq SRadVn 0)
				(setq SRadNar 0)
				(setq SWidth 0)
			)
		)
	)
)



;  
; 
(defun getSectXor ()
	(while (or (<= SAngle 0) (= SXor1 0))
		(setq SXor1 0)
		(initget 1 " ")
		(setq mode 1)
		(setq SXorType (getreal "\n  /<  >:"))
		(if (= SXorType "") 
			(progn
				(setq Mode 0)
				(setq SXor (getreal "\n  :"))
				(setq SXor1 (/ SXor 2))
				(if (<= SXor1 SRadVn)
					(progn
						(setq SXor1 (/ SXor 2))
						(setq X (sqrt (- (* SRadVn SRadVn) (* SXor1 SXor1))))
						(if (= X 0) (setq SAngle 180))
						(if (> X 0) (setq SAngle (* 2 (/ (* (atan (/ SXor1 X)) 180) pi))))
					)
				)
				(if (> SXor1 SRadVn)
					(progn
						(setq SAngle 0)
						(princ (strcat "\n   (" (rtos (* SXor1 2)) ")       (" (rtos (* 2 SRadVn)) ")"))
					)
				)

			)
		)
		(if (and (= SAngle 0) (= Mode 1))
			(progn
				(setq SXor1 (/ SXorType 2))
				(if (<= SXor1 SRadNar)
					(progn
						(setq SXor1 (/ SXorType 2))
						(setq X (sqrt (- (* SRadNar SRadNar) (* SXor1 SXor1))))
						(if (= X 0) (setq SAngle 180))
						(if (> X 0) (setq SAngle (* 2 (/ (* (atan (/ SXor1 X)) 180) pi))))
					)
				)
				(if (> SXor1 SRadNar)
					(progn
						(setq SAngle 0)
						(princ (strcat "\n   (" (rtos (* SXor1 2)) ")       (" (rtos (* 2 SRadNar)) ")."))
					)
				)
			)
		)
	)
)


;   
; 
(defun getSectLen ()
	(while (<= SAngle 0)
		(initget 1 " ")
		(setq Mode 1)
		(setq SLenType (getreal "\n   /<   >:"))
		(if (= SLenType "") 
			(progn
				(setq Mode 0)
				(setq SLen (getreal "\n   :"))
				(if (< SLen (* 2 pi SRadVn))
					(setq SAngle (/ (* 180 SLen) (* pi SRadVn)))
				)
				(if (> SLen (* 2 pi SRadVn))
					(progn
						(princ (strcat "\n    (" (rtos SLen) ")         (" (rtos (* 2 pi SRadVn)) ")."))
					)
				)
			)
		)
		(if (and (= Mode 1) (<= SAngle 0))
			(progn
				(if (< SLenType (* 2 pi SRadNar))
					(setq SAngle (/ (* 180 SLenType) (* pi SRadNar)))
				)
				(if (> SLenType (* 2 pi SRadVn))
					(progn
						(princ (strcat "\n    (" (rtos SLenType) ")         (" (rtos (* 2 pi SRadNar)) ")."))
					)
				)
			)
		) 
	)
)

; 
; 
	
	;    
	;    
	;SRadNar -   
	;SRadVn -   
	;SAngle -  

(defun DrawSect (BasePt SRadNar SRadVn SAngle)
	
	(Osnap_Off)
	
	;       bp
	(setq bpx (car BasePt))
	(setq bpy (cadr BasePt))
	(setq bpz (caddr BasePt))
	
	(setq dy (* SRadNar (cos (/ (dtr SAngle) 2))))
	(if (< SAngle 180.0)
		(progn
			(setq dx (* SRadNar (sin (/ (dtr SAngle) 2)))) 
			(setq dy (- dy (* (cos (/ (dtr SAngle) 2)) (- SRadNar SRadVn))))
			(setq dy (- dy))
		)
		(progn
			(setq dx SRadNar)
			(setq dy (* (sin (- (/ (dtr SAngle) 2) (dtr 90.0) )) SRadNar))
		)	
	)
		
	(setq SCentPT (list (+ bpx dx) (+ bpy dy) (+ bpz 0)))	; 
															;
	
	;  
	(setq SWidth (- SRadNar SRadVn))	; 

	(setq SAngle1 (dtr (/ SAngle 2))) 	;  
										; 
										
	; 
	(setq pt1 (polar SCentPT (+ (dtr 90) SAngle1) SRadVn))
	(setq pt2 (polar SCentPT (dtr 90) SRadVn))
	(setq pt3 (polar SCentPT (- (dtr 90) SAngle1) SRadVn))
	(setq pt4 (polar SCentPT (- (dtr 90) SAngle1) SRadNar))
	(setq pt5 (polar SCentPT (dtr 90) SRadNar))
	(setq pt6 (polar SCentPT (+ (dtr 90) SAngle1) SRadNar))
	
	(setq S1 nil)
	(setq S1 (ssadd))
	(command "_Pline"
		pt1
		"Arc" "Second"
		pt2
		pt3
		"Line"
		pt4
		"Arc" "Second"
		pt5
		pt6
		"Line"
		"CLose"
	)
	(ssadd (entlast) S1)
	
	(Osnap_On)
	
	T S1
)





;   
; ,     
;   : SectorA
(defun C:SectorA ()
	(SetOpt)
	
	(setq SRadNar 0)
	(setq SRadVn 0)
	(setq SWidth 0)
	(setq SAngle 0)
	
	(getSectRad)
	
	(while (or (= SAngle 0) (>= SAngle 360))
		(setq HelpTXT (strcat "\n   : "))
		(initget 1)
		(setq SAngle (getreal HelpTXT))
		(if (>= SAngle 360)
			(progn
				(princ (strcat "\n   (" (rtos SAngle) ")       360 ."))
				(setq SAngle 0)
			)
		)
	)
	
	(SetOpt)
	
	(setq flag nil)
    (setq S1 nil)
	(setq S1 (ssadd))
	(setq bp (grread T (+ 1 4) 0))	;   
	(if (= 5 (car bp))		;      
							;    
		(progn
			(setq bp1 (car (cdr bp)))
			(setq SectObj (DrawSect bp1 SRadNar SRadVn SAngle))	;
																;
		)
	)
	(princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	;      
							;    
			(progn
				(setq bp2 (car (cdr bp)))
				(command "_erase" SectObj "")	; 
    			(setq SectObj nil)
				(setq SectObj (ssadd))
				;    
				(setq SectObj (DrawSect bp2 SRadNar SRadVn SAngle))
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
				(setq flag T)
		)
	)
	T bp2
	(Osnap_Off)
	(RotateObj SectObj bp2)	; 
	(Osnap_On)
	(RetOpt)
)


;   
; ,     
;   : SectorX
(defun C:SectorX ()
	(SetOpt)
	
	(setq SRadNar 0)
	(setq SRadVn 0)
	(setq SXor 0)
	(setq SAngle 0)
	(setq SWidth 0)
	
	(getSectRad)
	
	(getSectXor)
	
	(SetOpt)
	
	(setq flag nil)
    (setq S1 nil)
	(setq S1 (ssadd))
	(setq bp (grread T (+ 1 4) 0))	;   
	(if (= 5 (car bp))		;      
							;    
		(progn
			(setq bp1 (car (cdr bp)))
			(setq SectObj (DrawSect bp1 SRadNar SRadVn SAngle))	;
																;
		)
	)
	(princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	;      
							;    
			(progn
				(setq bp2 (car (cdr bp)))
				(command "_erase" SectObj "")	; 
    			(setq SectObj nil)
				(setq SectObj (ssadd))
				;    
				(setq SectObj (DrawSect bp2 SRadNar SRadVn SAngle))
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
				(setq flag T)
		)
	)
	T bp2
	(Osnap_Off)
	(RotateObj SectObj bp2)	; 
	(Osnap_On)
	(RetOpt)
)

;   
; ,      
;   : SectorL
(defun C:SectorL ()
	(SetOpt)
	
	(setq SRadNar 0)
	(setq SRadVn 0)
	(setq SLen 0)
	(setq SAngle 0)
	(setq SWidth 0)
	
	(getSectRad)
	
	(getSectLen)
	
	(SetOpt)
	
	(setq flag nil)
    (setq S1 nil)
	(setq S1 (ssadd))
	(setq bp (grread T (+ 1 4) 0))	;   
	(if (= 5 (car bp))		;      
							;    
		(progn
			(setq bp1 (car (cdr bp)))
			(setq SectObj (DrawSect bp1 SRadNar SRadVn SAngle))	;
																;
		)
	)
	(princ "\n : ")
	(while (not flag)
		(setq bp (grread T (+ 1 4) 0))	;   
		(if (= 5 (car bp))	;      
							;    
			(progn
				(setq bp2 (car (cdr bp)))
				(command "_erase" SectObj "")	; 
				(setq SectObj nil)
				(setq SectObj (ssadd))
				;    
				(setq SectObj (DrawSect bp2 SRadNar SRadVn SAngle))
			)
		)
		
		(if (equal 3 (car bp)) 	;     
								; 
			(setq flag T)
		)
	)
	
	(Osnap_Off)
	T bp2
	(RotateObj SectObj bp2)		; 
	(Osnap_On)
	(RetOpt)
)

;=============================================================
(princ "\n     SectorA  ")
(princ "\n     SectorX  ")
(princ "\n     SectorL  ")
(princ)
